package com.supermap.samplecode.data;

import java.awt.Component;
import java.io.File;
import java.util.ArrayList;

import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;

import com.supermap.data.Workspace;
import com.supermap.data.WorkspaceConnectionInfo;
import com.supermap.data.WorkspaceType;
import com.supermap.data.WorkspaceVersion;

/**
 * <p>
 * Title:工作空间管理
 * </p>
 * 
 * <p>
 * Description:
 * ============================================================================>
 * ------------------------------版权声明---------------------------- 
 * 此文件为SuperMap Objects Java 的示范代码
 * 版权所有：北京超图软件股份有限公司
 * ----------------------------------------------------------------
 * ---------------------SuperMap iObjects Java 示范程序说明------------------------
 * 
 * 1、范例简介：示范打开、另存、创建、删除文件型和数据库型工作空间 
 * 2、示例数据：无 
 * 3、关键类型/成员: 
 * Workspace.open 方法
 * Workspace.saveAs 方法 
 * Workspace.create 方法 
 * Workspace.deleteWorkspace 方法 
 * 4、使用步骤：
 * (6)The above steps are also applicable to the database type workspace.
 * (1)点选打开工作空间页标签，打开示范数据工作空间
 * (2)点选另存工作空间页标签，将打开的工作空间存放的磁盘的其他位置
 * (3)可打开另存的工作空间文件查看
 * (4)点选删除工作空间页标签，将新另存的工作空间删除
 * (5)点选创建工作空间页标签，在磁盘的某位置新创建工作空间
 * (6)以上步骤同样适用于数据库型工作空间
 * ----------------------------------------------------------
 * --------------------
 * ============================================================================>
 * </p>
 * 
 * <p>
 * Company: 北京超图软件股份有限公司
 * </p>
 * 
 */

/**
 * <p>
 * Title:Manage Workspace
 * </p>
 * 
 * <p>
 * Description:
 * ============================================================================>
 * ------------------------------Copyright Statement----------------------------
 * SuperMap Objects Java Sample Code 
 * Copyright: SuperMap Software Co., Ltd. All Rights Reserved.
 * ------------------------------------------------------------------------------
 *-----------------------Description--------------------------
 * 
 * 1、Sample Code Description：This sample demonstrates how to open, create, saveas or delete the workspace. 
 * 2、Sample Data Location:None
 * 3、Key Classes/Methods:
 * Workspace.open method
 * Workspace.saveAs method
 * Workspace.create method
 * Workspace.deleteWorkspace method 
 * 4、Procedures:
  * (1)Click the opening workspace label to open the demonstration workspace.
 * (2)Click the SaveAs workspace label to save the workspace as another workspace.
 * (3)Open the SaveAs workspace to view.
 * (4)Click the Delete label to delete the SaveAs workspace.
 * (5)Click the Create label to Create a new workspace.

 * ----------------------------------------------------------
 * --------------------
 * ============================================================================>
 * </p>
 * 
 * <p>
 * Company: SuperMap Software Co., Ltd.
 * </p>
 * 
 */

public class SampleRun {
	private Workspace m_workspace;

	private JFileChooser m_fileChooser;

	//执行程序所需要的数据
	//Data
	private String m_opensu = "";
	private String m_openfa = "";
	private String m_createsu = "";
	private String m_createfa = "";
	private String m_savesu = "";
	private String m_savefa = "";
	private String m_deletesu = "";
	private String m_deletefa = "";
	private String m_info = "";
	private String m_server = "";
	private String m_databasename = "";
	private String m_username = "";
	private String m_workspacename = "";
	private String m_workspacetype = "";
	private String m_workspacedatasource = "";
	private String m_index = "：";
	private String m_print = "";
	private String m_mapinfo = "";
	private String m_mapindex = "";
	private String m_filterAll = "";
	private String m_filterSxw = "";
	private String m_filterSmw = "";
	private String m_filterSxwu = "";
	private String m_filterSmwu = "";
	/**
	 * 根据workspace和map构造 SampleRun对象
	 * Initialize the SampleRun object with the specified workspace
	 */
	public SampleRun(Workspace workspace) {
		this.m_workspace = workspace;
		InitializeCultureResources();
	}

	/**
	* 初始化多语言资源
	* Initialize CultureResources
	*/
	private void InitializeCultureResources()
	{
		if(com.supermap.data.Environment.getCurrentCulture().contentEquals("zh-CN"))
		{
			m_opensu = "打开工作空间成功！";
			m_openfa = "打开工作空间失败！";
			m_createsu = "创建工作空间成 功！";
			m_createfa = "创建工作空间失 败！";
			m_savesu = "另存工作空间成 功！";
			m_savefa = "另存工作空间失 败！";
			m_deletesu = "删除工作空间成功！";
			m_deletefa = "删除工作空间失败！";
			m_info = "工作空间基本信息：\n";
			m_server = "服务器名或文件路径：";
			m_databasename = "数据库名：";
			m_username = "用户名：";
			m_workspacename = "工作空间名称：";
			m_workspacetype = "工作空间类型：";
			m_workspacedatasource = "工作空间中数据源信息：\n";
			m_index = "数据源编号：";
			m_print = "工作空间中没有数据源！\n";
			m_mapinfo = "工作空间中地图信息：\n";
			m_mapindex = "地图编号：";
			m_filterAll = "SuperMap工作空间文件(*.sxw,*.smw,*.sxwu,*.smwu)";
			m_filterSxw = "SuperMap工作空间文件(*.sxw)";
			m_filterSmw = "SuperMap工作空间文件(*.smw)";
			m_filterSxwu = "SuperMap工作空间文件(*.sxwu)";
			m_filterSmwu = "SuperMap工作空间文件(*.smwu)";
			
		}
		else
		{	
			m_opensu = "Success to open the workspace!";
			m_openfa = "Fail to open the workspace!";
			m_createsu = "Success to create the workspace!";
			m_createfa = "Fail to create the workspace!";
			m_savesu = "Success to save the current workspace as another workspace!";
			m_savefa = "Fail to save the current workspace as another workspace!";
			m_deletesu = "Success to delete the workspace!";
			m_deletefa = "Fail to delete the workspace!";
			m_info = "Workspace basic information:\n";
			m_server = "Server or Path:";
			m_databasename = "Database Name：";
			m_username = "User Name：";
			m_workspacename = "Workspace Name：";
			m_workspacetype = "Workspace Type：";
			m_workspacedatasource = "Datasource Information in the workspace：\n";
			m_index = "Datasource Serial Number：";
			m_print = "There is no datasource in the current workspace!\n";
			m_mapinfo = "The map information in the current workspace：\n";
			m_mapindex = "Map Serial Number：";
			m_filterAll = "SuperMap Workspace File(*.sxw,*.smw,*.sxwu,*.smwu)";
			m_filterSxw = "SuperMap Workspace File(*.sxw)";
			m_filterSmw = "SuperMap Workspace File(*.smw)";
			m_filterSxwu = "SuperMap Workspace File(*.sxwu)";
			m_filterSmwu = "SuperMap Workspace File(*.smwu)";
		}
	}
	
	/**
	 * 打开文件型的工作空间
	 * Open the file type workspace
	 */
	public void openWorkspaceSXW(JTextField jTextFieldServer,
			JTextField jTextFieldPassword, JTextArea jTextAreaWorkspaceInfo) {
		m_workspace.dispose();
		m_workspace = new Workspace();

		String filePath = jTextFieldServer.getText();
		WorkspaceConnectionInfo connectionInfo = new WorkspaceConnectionInfo();
		connectionInfo.setServer(filePath);
		connectionInfo.setPassword(jTextFieldPassword.getText());
		if (filePath.endsWith(".sxw")) {
			connectionInfo.setType(WorkspaceType.SXW);
		} else if (filePath.endsWith(".smw")) {
			connectionInfo.setType(WorkspaceType.SMW);
		} else if (filePath.endsWith(".sxwu")) {
			connectionInfo.setType(WorkspaceType.SXWU);
		} else if (filePath.endsWith(".smwu")) {
			connectionInfo.setType(WorkspaceType.SMWU);
		}

		boolean openResult = m_workspace.open(connectionInfo);
		if (openResult) {
			appendWorkspaceInfo(jTextAreaWorkspaceInfo, m_workspace,
					connectionInfo, openResult);
		} else {
			jTextAreaWorkspaceInfo.setText(m_openfa);
		}
	}

	/**
	 * 打开数据库型的工作空间
	 * Open the database type workspace.
	 */
	public void openWorkspaceSQL(JTextField jTextFieldServer,
			JTextField jTextFieldDatabase, JTextField jTextFieldUserName,
			JTextField jTextFieldPassword, JTextField jTextFieldWorkspaceName,
			JTextArea jTextAreaWorkspaceInfo, int type) {
		m_workspace.dispose();
		m_workspace = new Workspace();

		WorkspaceConnectionInfo connectionInfo = new WorkspaceConnectionInfo();
		if (type == 1) {
			connectionInfo.setType(WorkspaceType.ORACLE);
		} else {
			connectionInfo.setDriver("SQL SERVER");
			connectionInfo.setType(WorkspaceType.SQL);
		}

		connectionInfo.setServer(jTextFieldServer.getText());
		connectionInfo.setDatabase(jTextFieldDatabase.getText());
		connectionInfo.setUser(jTextFieldUserName.getText());
		connectionInfo.setPassword(jTextFieldPassword.getText());
		connectionInfo.setName(jTextFieldWorkspaceName.getText());

		boolean openResult = m_workspace.open(connectionInfo);
		if (openResult) {
			appendWorkspaceInfo(jTextAreaWorkspaceInfo, m_workspace,
					connectionInfo, openResult);
		} else {
			jTextAreaWorkspaceInfo.setText(m_openfa);
		}
	}

	/**
	 * 另存文件型的工作空间
	 * The SaveAs workspace.
	 */
	public void workspaceSaveAsSXW(JTextField jTextFieldServer,
			JTextField jTextFieldWorkspaceName, JTextField jTextFieldPassword,
			JComboBox jComboBoxVersion, JComboBox jComboBoxType,
			JTextArea jTextAreaWorkspaceInfo) {

		WorkspaceConnectionInfo connectionInfo = new WorkspaceConnectionInfo();
		String filePath = jTextFieldServer.getText();
		String server = filePath + jTextFieldWorkspaceName.getText();

		if (jComboBoxType.getSelectedIndex() == 0) {
			server += ".sxw";
			connectionInfo.setType(WorkspaceType.SXW);
		}
		if (jComboBoxType.getSelectedIndex() == 1) {
			server += ".smw";
			connectionInfo.setType(WorkspaceType.SMW);
		}
		if (jComboBoxType.getSelectedIndex() == 2) {
			server += ".sxwu";
			connectionInfo.setType(WorkspaceType.SXWU);
		}
		if (jComboBoxType.getSelectedIndex() == 3) {
			server += ".smwu";
			connectionInfo.setType(WorkspaceType.SMWU);
		}

		if (jComboBoxVersion.getSelectedIndex() == 0) {
			connectionInfo.setVersion(WorkspaceVersion.UGC60);
		} else if (jComboBoxVersion.getSelectedIndex() == 1) {
			connectionInfo.setVersion(WorkspaceVersion.UGC20);
		} else {
			connectionInfo.setVersion(WorkspaceVersion.SFC60);
		}

		connectionInfo.setServer(server);
		connectionInfo.setPassword(jTextFieldPassword.getText());

		boolean openResult = m_workspace.saveAs(connectionInfo);
		if (openResult) {
			jTextAreaWorkspaceInfo.setText(m_savesu);
		} else {
			jTextAreaWorkspaceInfo.setText(m_savefa);
		}
	}

	/**
	 * 另存数据库型的工作空间
	 * The SaveAs database type workspace.
	 */
	public void workspaceSaveAsSQL(JTextField jTextFieldServer,
			JTextField jTextFieldDatabase, JTextField jTextFieldUserName,
			JTextField jTextFieldPassword, JTextField jTextFieldWorkspaceName,
			JComboBox jComboBoxVersion, JTextArea jTextAreaWorkspaceInfo,
			int type) {
		WorkspaceConnectionInfo connectionInfo = new WorkspaceConnectionInfo();
		if (type == 1) {
			connectionInfo.setType(WorkspaceType.ORACLE);
		} else {
			connectionInfo.setDriver("SQL SERVER");
			connectionInfo.setType(WorkspaceType.SQL);
		}

		connectionInfo.setServer(jTextFieldServer.getText());
		connectionInfo.setDatabase(jTextFieldDatabase.getText());
		connectionInfo.setUser(jTextFieldUserName.getText());
		connectionInfo.setPassword(jTextFieldPassword.getText());
		connectionInfo.setName(jTextFieldWorkspaceName.getText());

		if (jComboBoxVersion.getSelectedIndex() == 0) {
			connectionInfo.setVersion(WorkspaceVersion.UGC60);
		} else if (jComboBoxVersion.getSelectedIndex() == 1) {
			connectionInfo.setVersion(WorkspaceVersion.UGC20);
		} else {
			connectionInfo.setVersion(WorkspaceVersion.SFC60);
		}

		boolean saveResult = m_workspace.saveAs(connectionInfo);
		if (saveResult) {
			jTextAreaWorkspaceInfo.setText(m_opensu);
		} else {
			jTextAreaWorkspaceInfo.setText(m_openfa);
		}
	}

	/**
	 * 创建文件型的工作空间
	 * Create the file type workspace.
	 */
	public void createWorkspaceSXW(JTextField jTextFieldServer,
			JTextField jTextFieldWorkspaceName, JTextField jTextFieldPassword,
			JComboBox jComboBoxVersion, JComboBox jComboBoxType,
			JTextArea jTextAreaWorkspaceInfo) {

		m_workspace.dispose();
		m_workspace = new Workspace();
		WorkspaceConnectionInfo connectionInfo = new WorkspaceConnectionInfo();

		String filePath = jTextFieldServer.getText();
		String server = filePath + jTextFieldWorkspaceName.getText();

		if (jComboBoxType.getSelectedIndex() == 0) {
			server += ".sxw";
			connectionInfo.setType(WorkspaceType.SXW);
		}
		if (jComboBoxType.getSelectedIndex() == 1) {
			server += ".smw";
			connectionInfo.setType(WorkspaceType.SMW);
		}
		if (jComboBoxType.getSelectedIndex() == 2) {
			server += ".sxwu";
			connectionInfo.setType(WorkspaceType.SXWU);
		}
		if (jComboBoxType.getSelectedIndex() == 3) {
			server += ".smwu";
			connectionInfo.setType(WorkspaceType.SMWU);
		}

		if (jComboBoxVersion.getSelectedIndex() == 0) {
			connectionInfo.setVersion(WorkspaceVersion.UGC60);
		} else if (jComboBoxVersion.getSelectedIndex() == 1) {
			connectionInfo.setVersion(WorkspaceVersion.UGC20);
		} else {
			connectionInfo.setVersion(WorkspaceVersion.SFC60);
		}

		connectionInfo.setServer(server);
		connectionInfo.setPassword(jTextFieldPassword.getText());

		boolean openResult = m_workspace.create(connectionInfo);
		if (openResult) {
			jTextAreaWorkspaceInfo.setText(m_createsu);
		} else {
			jTextAreaWorkspaceInfo.setText(m_createfa);
		}
	}

	/**
	 * 创建数据库型的工作空间
	 * Create the database type workspace.
	 */
	public void createWorkspaceSQL(JTextField jTextFieldServer,
			JTextField jTextFieldDatabase, JTextField jTextFieldUserName,
			JTextField jTextFieldPassword, JTextField jTextFieldWorkspaceName,
			JComboBox jComboBoxVersion, JTextArea jTextAreaWorkspaceInfo,
			int type) {
		m_workspace.dispose();
		m_workspace = new Workspace();
		WorkspaceConnectionInfo connectionInfo = new WorkspaceConnectionInfo();

		if (type == 1) {
			connectionInfo.setType(WorkspaceType.ORACLE);
		} else {
			connectionInfo.setDriver("SQL SERVER");
			connectionInfo.setType(WorkspaceType.SQL);
		}

		connectionInfo.setServer(jTextFieldServer.getText());
		connectionInfo.setDatabase(jTextFieldDatabase.getText());
		connectionInfo.setUser(jTextFieldUserName.getText());
		connectionInfo.setPassword(jTextFieldPassword.getText());
		connectionInfo.setName(jTextFieldWorkspaceName.getText());

		if (jComboBoxVersion.getSelectedIndex() == 0) {
			connectionInfo.setVersion(WorkspaceVersion.UGC60);
		} else if (jComboBoxVersion.getSelectedIndex() == 1) {
			connectionInfo.setVersion(WorkspaceVersion.UGC20);
		} else {
			connectionInfo.setVersion(WorkspaceVersion.SFC60);
		}

		boolean saveResult = m_workspace.create(connectionInfo);
		if (saveResult) {
			jTextAreaWorkspaceInfo.setText(m_createsu);
		} else {
			jTextAreaWorkspaceInfo.setText(m_createfa);
		}
	}

	/**
	 * 删除文件型的工作空间
	 * Delete the file type workspace.
	 */
	public void deleteWorkspaceSXW(JTextField jTextFieldServer,
			JTextField jTextFieldPassword, JComboBox jComboBoxType,
			JTextArea jTextAreaWorkspaceInfo) {

		WorkspaceConnectionInfo connectionInfo = new WorkspaceConnectionInfo();
		String filePath = jTextFieldServer.getText();

		if (jComboBoxType.getSelectedIndex() == 0) {
			connectionInfo.setType(WorkspaceType.SXW);
		}
		if (jComboBoxType.getSelectedIndex() == 1) {
			connectionInfo.setType(WorkspaceType.SMW);
		}
		if (jComboBoxType.getSelectedIndex() == 2) {
			connectionInfo.setType(WorkspaceType.SXWU);
		}
		if (jComboBoxType.getSelectedIndex() == 3) {
			connectionInfo.setType(WorkspaceType.SMWU);
		}

		connectionInfo.setServer(filePath);
		connectionInfo.setPassword(jTextFieldPassword.getText());

		boolean openResult = Workspace.deleteWorkspace(connectionInfo);
		if (openResult) {
			jTextAreaWorkspaceInfo.setText(m_deletesu);
		} else {
			jTextAreaWorkspaceInfo.setText(m_deletefa);
		}
	}

	/**
	 * 删除数据库型的工作空间
	 * Delete the database type workspace.
	 */
	public void deleteWorkspaceSQL(JTextField jTextFieldServer,
			JTextField jTextFieldDatabase, JTextField jTextFieldUserName,
			JTextField jTextFieldPassword, JTextField jTextFieldWorkspaceName,
			JTextArea jTextAreaWorkspaceInfo, int type) {
		WorkspaceConnectionInfo connectionInfo = new WorkspaceConnectionInfo();

		if (type == 1) {
			connectionInfo.setType(WorkspaceType.ORACLE);
		} else {
			connectionInfo.setDriver("SQL SERVER");
			connectionInfo.setType(WorkspaceType.SQL);
		}

		connectionInfo.setServer(jTextFieldServer.getText());
		connectionInfo.setDatabase(jTextFieldDatabase.getText());
		connectionInfo.setUser(jTextFieldUserName.getText());
		connectionInfo.setPassword(jTextFieldPassword.getText());
		connectionInfo.setName(jTextFieldWorkspaceName.getText());

		boolean saveResult = Workspace.deleteWorkspace(connectionInfo);
		if (saveResult) {
			jTextAreaWorkspaceInfo.setText(m_deletesu);
		} else {
			jTextAreaWorkspaceInfo.setText(m_deletefa);
		}
	}

	/**
	 * 打开工作空间面板中选择文件路径
	 * Choose the file path on the Open workspace panel.
	 */
	public void browseWorkspaceSXW(Component panel, JTextField jTextField) {
		int value = initializeFileChooser(panel);
		if (value == 1) {
			return;
		}
		File selectedFile = m_fileChooser.getSelectedFile();
		if (selectedFile == null) {
			return;
		}
		String filePath = selectedFile.getPath();
		jTextField.setText(filePath);
	}

	/**
	 * 另存工作空间面板中选择文件夹路径
	 * Choose the folder path on the SaveAs workspace panel
	 */
	public void browseWorkspaceSXWSaveAs(JPanel panel, JTextField jTextField) {
		int value = initializeFileChooserSaveAs(panel);
		if (value == 1) {
			return;
		}
		File selectedFile = m_fileChooser.getSelectedFile();
		if (selectedFile == null) {
			return;
		}
		String filePath = selectedFile.getPath();
		jTextField.setText(filePath + "\\");
	}

	/**
	 * 向文本域中添加打开的工作空间的信息
	 * Add the information of the current workspace to the text. 
	 */
	private void appendWorkspaceInfo(JTextArea jTextArea, Workspace workspace,
			WorkspaceConnectionInfo connectionInfo, boolean openResult) {
		if (openResult) {
			try {
				jTextArea.append(m_info);
				jTextArea.append(m_server+ connectionInfo.getServer()
						+ "\n");
				jTextArea.append(m_databasename + connectionInfo.getDatabase() + "\n");
				jTextArea.append(m_username + connectionInfo.getUser() + "\n");
				jTextArea.append(m_workspacename + connectionInfo.getName() + "\n");
				jTextArea.append(m_workspacetype
						+ connectionInfo.getType().toString() + "\n");
				jTextArea.append("******************************\n");

				jTextArea.append(m_workspacedatasource);
				if (workspace.getDatasources().getCount() > 0) {
					for (int i = 0; i < workspace.getDatasources().getCount(); i++) {
						jTextArea.append(m_index + i + ": "
								+ workspace.getDatasources().get(i).getAlias()
								+ "\n");
					}
				} else {
					jTextArea.append(m_print);
				}
				jTextArea.append("******************************\n");
				jTextArea.append(m_mapinfo);
				if (workspace.getMaps().getCount() > 0) {
					for (int i = 0; i < workspace.getMaps().getCount(); i++) {
						jTextArea.append(m_mapindex + i + ": "
								+ workspace.getMaps().get(i) + "\n");
					}
				} else {
					jTextArea.append(m_mapinfo);
				}
			} catch (Exception e) {
				System.out.println(e.getMessage());
			}
		} else {
			jTextArea.append(m_openfa);
		}

	}

	/**
	 * 为文件型的工作空间初始化文件选择对话框，该方法用于打开和删除工作空间，仅能选择文件
	 * Initialize the JFileChooset.The method is used to open and delete the workspace,and it only select files.
	 */
	private int initializeFileChooser(Component panel) {
		m_fileChooser = new JFileChooser();
		FileNameExtensionFilter filterAll = new FileNameExtensionFilter(
				m_filterAll, "sxw", "smw",
				"sxwu", "smwu");
		filterAll.addExtension("sxw");
		filterAll.addExtension("smw");
		filterAll.addExtension("sxwu");
		filterAll.addExtension("smwu");
		FileNameExtensionFilter filterSxw = new FileNameExtensionFilter(
				m_filterSxw, "sxw");
		filterSxw.addExtension("sxw");
		FileNameExtensionFilter filterSmw = new FileNameExtensionFilter(
				m_filterSmw, "smw");
		filterSmw.addExtension("smw");
		FileNameExtensionFilter filterSxwu = new FileNameExtensionFilter(
				m_filterSxwu, "sxwu");
		filterSxwu.addExtension("sxwu");
		FileNameExtensionFilter filterSmwu = new FileNameExtensionFilter(
				m_filterSmwu, "smwu");
		filterSmwu.addExtension("smwu");
		m_fileChooser.addChoosableFileFilter(filterAll);
		m_fileChooser.addChoosableFileFilter(filterSxw);
		m_fileChooser.addChoosableFileFilter(filterSmw);
		m_fileChooser.addChoosableFileFilter(filterSxwu);
		m_fileChooser.addChoosableFileFilter(filterSmwu);
		m_fileChooser.setFileFilter(filterAll);
		m_fileChooser.setCurrentDirectory(new File("../../SampleData"));

		m_fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		return m_fileChooser.showOpenDialog(panel);
	}

	/**
	 * 为文件型的工作空间初始化文件选择对话框，该方法用于另存和创建工作空间，仅能选择文件夹
	 * Initialize the JFileChooset.The method is used to SaveAs and create the workspace,and it only select folders.
	 */
	private int initializeFileChooserSaveAs(JPanel panel) {
		m_fileChooser = new JFileChooser();
		FileNameExtensionFilter filter = new FileNameExtensionFilter("", "sxw",
				"smw", "sxwu", "smwu");
		m_fileChooser.addChoosableFileFilter(filter);
		m_fileChooser.setCurrentDirectory(new File("../../SampleData"));
		m_fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		return m_fileChooser.showOpenDialog(panel);
	}
}

/**
 * 内部类，实现文件选择对话框
 * Internal Class to the JFileChooser.
 */
class FileNameExtensionFilter extends FileFilter {
	private String str = "";
	private ArrayList<String> m_extensions = new ArrayList<String>();

	public FileNameExtensionFilter(String description, String... extensions) {
		this.setDescription(description);
		for (String extension : extensions) {
			this.addExtension(extension);
		}
	}

	public void addExtension(String extension) {
		if (!extension.startsWith(".")) {
			extension = "." + extension;
		}
		m_extensions.add(extension.toLowerCase());
	}

	public String[] getExtensions() {
		String[] result = new String[m_extensions.size()];
		return m_extensions.toArray(result);
	}

	public void setDescription(String aDescription) {
		str = aDescription;
	}

	public String getDescription() {
		return str;
	}

	@Override
	public boolean accept(File f) {
		if (f.isDirectory()) {
			return true;
		}
		String name = f.getName().toLowerCase();
		for (String extension : m_extensions) {
			if (name.endsWith(extension)) {
				return true;
			}
		}
		return false;
	}
}

